import time
import pickle
import os

class Database():
    class FormatList():
        def __init__(self, data=None):
            self._lastUpdate = -1
            self._items = []
            if data != None:
                self.update(data)

        def update(self, items):
            self._items = items
            self._lastUpdate = time.time()

        def get(self):
            return self._items

        def lastUpdate(self):
            return self._lastUpdate

    def __init__(self, dbFile):
        self._data = {}
        self._dbFile = dbFile
        if os.path.isfile(self._dbFile):
            with open(self._dbFile, 'rb') as f:
                try:
                    self._data = pickle.load(f)
                except:
                    print("Failed to parse database")
                    pass

    def get(self, dictType):
        data = self._data.get(dictType)
        if data != None:
            if not self.updateNecessary(data):
                return data.get()
        return None
    def set(self, dictType, data):
        self._data[dictType] = self.FormatList(data)
        with open(self._dbFile, "wb") as f:
            pickle.dump(self._data, f)

    @staticmethod
    def updateNecessary(data : FormatList):
        try:
            if (data.lastUpdate() + (60 * 60 * 24)) > time.time():
                return False
        except:
            pass
        return True
